#!/bin/sh

# get instance id from instance metadata
EC2_INSTANCE_ID=$( curl -s http://169.254.169.254/latest/meta-data/instance-id )

# get and parse instance region from instance metadata
EC2_INSTANCE_REGION=$( curl -s http://169.254.169.254/latest/meta-data/placement/availability-zone )
EC2_INSTANCE_REGION=$( echo "$EC2_INSTANCE_REGION" | sed 's|[a-z]$||g' )

# the below commented command is to get the EC2 running instance state
#EC2_COMMAND="aws ec2 describe-instances --instance-ids $EC2_INSTANCE_ID --region ap-south-1 --query Reservations[0].Instances[0].State.Name"

# the below command is to get the EC2 instance lifecycle state from auto-scaling group
EC2_COMMAND="aws autoscaling describe-auto-scaling-instances --instance-ids $EC2_INSTANCE_ID --region $EC2_INSTANCE_REGION --query AutoScalingInstances[0].LifecycleState --output text"

while sleep 2; do

	# get and parse the instance lifecycle state
	EC2_INSTANCE_STATE="$( $EC2_COMMAND )"
	#EC2_INSTANCE_STATE=$( echo $EC2_INSTANCE_STATE | sed 's|\"||g' )

	# if the lifecycle transits into Terminating:Wait, run the script to delete the IDP node
        if [ $EC2_INSTANCE_STATE == "Terminating:Wait" ]; then
		echo "now execute script deleteIDPNode.sh"
		exit 0
        fi
	# continue probing for the state

done
