import json
import sys

def get_sessions_in_idp():
    try:
        print(parsed_response[0]["numSessions"])
    except:
        print_to_log_file("json_parser.py:get_sessions_in_idp: Response could not be parsed")
        print("failure")        
        sys.exit()

def get_idp_cluster_id():
    try:
        cluster_name = sys.argv[3]
        clusters = parsed_response["idpClusterList"]["idpCluster"]
        for cluster in clusters:
            if cluster["displayName"] == cluster_name:
                cluster_id = cluster["instanceID"]
                print(cluster_id)
    except IndexError:
        print_to_log_file("json_parser.py:get_idp_cluster_id: Required arguments are not passed")
        print("failure")
        sys.exit()
    except:
        print_to_log_file("json_parser.py:get_idp_cluster_id: Response could not be parsed")
        print("failure")
        sys.exit()

def get_ag_cluster_id():
    try:
        cluster_name = sys.argv[3]
        clusters = parsed_response["agClusterList"]["agCluster"]
        for cluster in clusters:
            if cluster["displayName"] == cluster_name:
                cluster_id = cluster["instanceID"]
                print(cluster_id)
    except IndexError:
        print_to_log_file("json_parser.py:get_ag_cluster_id: Required arguments are not passed")
        print("failure")
        sys.exit()
    except:
        print_to_log_file("json_parser.py:get_ag_cluster_id: Response could not be parsed")
        print("failure")
        sys.exit()

def get_primary_ag():
    try:
        cluster_name = sys.argv[3]
        clusters = parsed_response["agClusterList"]["agCluster"]
        for cluster in clusters:
            if cluster["displayName"] == cluster_name:
                primary_ag = cluster["primaryDeviceID"]
                print(primary_ag)
    except IndexError:
        print_to_log_file("json_parser.py:get_primary_ag: Required arguments are not passed")
        print("failure")
        sys.exit()
    except:
        print_to_log_file("json_parser.py:get_primary_ag: Response could not be parsed")
        print("failure")
        sys.exit()


def get_primary_ag_ip():
    try:
        print( parsed_response["agDevice"]["displayName"])
    except IndexError:
        print("json_parser.py:get_primary_ag_ip: Required arguments are not passed")
        print("failure")
        sys.exit()
    except:
        print("json_parser.pyy:get_primary_ag_ip: Response could not be parsed")
        print("failure")
        sys.exit()



def print_to_log_file(message):
    try:
        old_stdout = sys.stdout

        log_location = sys.argv[2]
        log_file = open(log_location,"w")
    
        sys.stdout = log_file
        print(message)
        sys.stdout = old_stdout

        log_file.close()
    except:
        print("failure")
        sys.exit()

try:
    response = sys.argv[1]
    parsed_response = json.loads(response)
except IndexError:
    print_to_log_file("json_parser.py: Required arguments are not passed")
    print("failure")
    sys.exit()
except ValueError:
    print_to_log_file("json_parser.py: No JSON object could be decoded")
    print("failure")
    sys.exit()
except:
    print("failure")
    sys.exit() 
